﻿using System;
using System.IO;

namespace Bücherwurm
{
    class Program
    {
        private static Administration Admin {get; set;}
        public static void Main(string[] args)
        {
            Admin = new Administration();
            if (args.Length == 1)
            {
                Console.WriteLine("Versuche JSON Katalog von {0} zu importieren...", args[0]);
                string jsonString = File.ReadAllText(args[0]);
                Admin.MakeImport(jsonString);
                Console.WriteLine("Erfolg!");
            }
            var Continue = true;
            do
            {
                Console.WriteLine("Bitte geben Sie den Buchstaben für den Gewünschten Bereich an:");
                Console.Write("(K)atalog, (I)nventar, (A)usleihe, Program beenden (X):");
                var CategorySelect = Console.ReadLine().ToLower();
                switch (CategorySelect)
                {
                    case "k":
                    {
                        CatalogueSelection();
                        break;
                    }
                    case "i":
                    {
                        InventorySelection();
                        break;
                    }
                    case "a":
                    {
                        LendingSelection();
                        break;
                    }
                    case "x":
                    {
                        Continue = false;
                        break;
                    }
                    default:
                    {
                        Console.WriteLine("Unbekannte Aktion: {0}", CategorySelect);
                        break;
                    }
                }
            } while (Continue);
        }

        private static void CatalogueSelection()
        {
            var Continue = true;
            do
            {
            Console.WriteLine("Bitte geben Sie den Buchstaben für die gewünschte Aktion an:");
            Console.WriteLine("Katalog auf(l)isten, Bu(c)h hinzufügen, Buch entfe(r)nen, Katalog verlassen (x):");
            var CatalogueSelect = Console.ReadLine().ToLower();
                switch (CatalogueSelect)
                {
                    case "x":
                    {
                        Continue = false;
                        break;
                    }
                    case "l":
                    {
                        Admin.ListCatalogue();
                        break;
                    }
                    case "c":
                    {
                        Admin.AddToCatalogue();
                        break;
                    }
                    case "r":
                    {
                        Admin.RemoveFromCatalogue();
                        break;
                    }
                    default:
                    {
                        Console.WriteLine("Ungültige Eingabe: {0}", CatalogueSelect);
                        break;
                    }
                }
            } while (Continue);
        }

        private static void InventorySelection()
        {
            var Continue = true;
            do
            {
            Console.WriteLine("Bitte geben Sie den Buchstaben für die gewünschte Aktion an:");
            Console.WriteLine("Inventar auf(l)isten, Exemplar hinzufügen (c), Exemplar entfe(r)nen, Inventar verlassen (x):");
            var InventorySelect = Console.ReadLine().ToLower();
                switch (InventorySelect)
                {
                    case "x":
                    {
                        Continue = false;
                        break;
                    }
                    case "l":
                    {
                        Admin.ListInventory();
                        break;
                    }
                    case "c":
                    {
                        Admin.AddToInventory();
                        break;
                    }
                    case "r":
                    {
                        Admin.RemoveFromInventory();
                        break;
                    }
                    default:
                    {
                        Console.WriteLine("Ungültige Eingabe: {0}", InventorySelect);
                        break;
                    }
                }
            } while (Continue);
        }

        private static void LendingSelection()
        {
            var Continue = true;
            do
            {
            Console.WriteLine("Bitte geben Sie den Buchstaben für die gewünschte Aktion an:");
            Console.WriteLine("Aktive Ausleihen auf(l)isten, Alle Ausleihen Aufli(s)ten, (A)usleihe tätigen, Ausleihe zu(r)ückgeben, Ausleihe verlassen (x):");
            var LendSelect = Console.ReadLine().ToLower();
                switch (LendSelect)
                {
                    case "x":
                    {
                        Continue = false;
                        break;
                    }
                    case "l":
                    {
                        Admin.ListActiveLendings();
                        break;
                    }
                    case "s":
                    {
                        Admin.ListAllLendings();
                        break;
                    }
                    case "a":
                    {
                        Admin.MakeLending();
                        break;
                    }
                    case "r":
                    {
                        Admin.ReturnLending();
                        break;
                    }
                    default:
                    {
                        Console.WriteLine("UNbekannte Eingabe: {0}", LendSelect);
                        break;
                    }
                }
            } while (Continue);
        }
    }
}
